=begin
njeremy2 may 2012
=end

Sketchup::require 'sketchup'

#We retrive the face to bore a hole. We use the pushpull to the next face.
class Trouer
	#Initialisation
	def activate
		@model = Sketchup.active_model
		@entities = @model.entities

		Sketchup::set_status_text("Cliquez sur une face pour la trouer", SB_PROMPT)
	end
	
	#When we push left button, we check if the selected thing is a face, then we use "trouerFace"
	def onLButtonDown(flags, x, y, view)
		pickHelper = view.pick_helper
		pickHelper.do_pick(x, y)
		face = pickHelper.picked_face
		if face
			trouerFace(face)
		end	
	end
	
	# Make a hole on the nearest face selected.
	def trouerFace(face)
		#We get all faces, norms, reversed norms and plans
		all_faces = []
		all_norms = []
		all_norms_reverse = []
		all_plans = []
		j = 0
		@entities.each do |current_ent|
			if current_ent.is_a?(Sketchup::Face)
			all_faces[j] = current_ent
			all_norms[j] = current_ent.normal
			all_norms_reverse[j] = current_ent.normal.reverse!
			all_plans[j] = current_ent.plane

						j = j + 1
			end # end if current_ent is_a face
			
		end #end current_ent
		
		#We get plan, norm, norm reverse and the first point
		plan = face.plane
		current_norm = face.normal
		current_norm_reverse =face.normal.reverse!
		first_point = face.vertices[0].position

		#We search the nearest parallele face 
		current_norm_reverse.length = 1000
		second_point = Geom::Point3d.new( (first_point[0] + current_norm_reverse[0]), 
											(first_point[1] + current_norm_reverse[1]),
											(first_point[2] + current_norm_reverse[2]))
		v_line = [Geom::Point3d.new(first_point), second_point] 
		k = 0
		all_dists = []
		mini = 10000
		ind_face = 0
		all_norms_reverse.each do |norm|
			if ( norm.parallel?(current_norm_reverse) and ( norm == current_norm ) and (plan[3] = all_plans[k][3]))
				# Calculate the distance between current_face and parallel faces
				paral_face = all_faces[k]
				paral_plan = paral_face.plane
				inters = Geom.intersect_line_plane(v_line, paral_plan)
				t = in_face( inters, paral_face )
				dist = first_point.distance_to_plane(paral_face.plane)
					if ( dist < mini ) and ( dist != 0 ) and t
					  mini = dist
					  ind_face = k
					end
			end
		  k = k + 1
		end
		if mini != 10000
			face.pushpull -mini
		end
	end
end

def in_face( p, f )
v = f.outer_loop.vertices
i = 0
sum_angles = 0
two_pi = Math::PI * 2 #6.28318530717959
0.upto (v.length - 1) do |a|
  if(i != (v.length - 1))
    vec1 = p.vector_to v[i] 
    vec2 = p.vector_to v[i + 1] 
    else
    vec1 = p.vector_to v[i] 
    vec2 = p.vector_to v[0]
  end
  sum_angles = sum_angles + vec1.angle_between(vec2)
  i = i + 1
end

  if( (two_pi - 0.1) < sum_angles) and ( sum_angles < (two_pi + 0.1))
    return true
    else
    return false
  end
end


if( not file_loaded?("testhole.rb") )
    UI.menu("Plugins").add_item("njeremy2 Hole") {
        Sketchup.active_model.select_tool Trouer.new }
end
#---------------------------------------------------------------------------
file_loaded("testhole.rb")